//------------------------------------------------------------------------------
// Starsiege Remote Interaction Script v2.0
// Script originally created by: Sentinal [MIB] | Sentinal07@hotmail.com
// Heavily modified and expanded by: Super Powio [MIB] | SuperPowio@gmail.com
// Thanks Robert "{GotLag}" McAfee for GLUtil.cs
//
// Copyright  2005 - Starsiege: Men In Black
//
// Starsiege: Men In Black website : http://mib.sunandshadows.com
// Starsiege: Static Screen : http://sunandshadows.com/staticscreen
//
// TO USE:
// Add exec("remoteInteract.cs"); to your autoexec.cs in the scripts folder to
// use this.
//
// NOTE:
// This script makes use of the removeEval command. Precautions have been taken
// so that no malacious or erroneous data will affect the client or the server.
// We only ask that both the script and client leave the script unmodified so as
// to not leave themselves vulnerable (as in crashing the game).
//
// CONTENTS:
// - RI::PollClientFile        : Requests file availability from the client
//
// - RI::SendConfirmDialog     : Sends a yes/no/cancel dialog box to the client
// - RI::SendInputDialog       : Sends a dialog with an input box to the client
// - RI::SendInput2Dialog      : Same as above, except with two dialog boxes
// - RI::SendOptionDialog      : Sends a dialog with a popup menu, with any
//                               number of choices defined by the sender!
//
//                               Note: The choices must be defined in one long
//                               string, delimited by commas (,). The same goes
//                               for the other option dialogs.
//
// - RI::SendOption2Dialog     : Same as above, except with two menus
// - RI::SendOptionInputDialog : Sends a dialog with both a popup menu and an
//                               input box
//
// Important: When writing a receiving command for a dialog, the function's
// header must be written in this format:
// function functionName(%player, %dialogID, %result1, %result2)
//
// Commands can only be sent from the server to the client. The client need only
// execute this script file and have RemoteInteact.vol to take advantage of the
// new dialog boxes.
//------------------------------------------------------------------------------

//Initialization stuff
if(!isObject($RI::Vol))
	$RI::Vol = newObject("RemoteInteractDialogs", SimVolume, "RemoteInteract.vol");
$RI::dlgCount = 0;

// Website Stuff
//------------------------------------------------------------------------------

// pollClientFile to be called in player::onAdd by server
// %filename is the name of the necessary file the client needs to download
// %website is the FULL web address to the download site (including http://www.)
// %filetype can be "terrain", "shapes", or whatever will sound correct in the messagebox
function RI::PollClientFile(%player, %filename, %website, %filetype)
{
   if(%filetype == "")
      %filetype = "file";
      
   if(isObject(2048))
   {
      echo("RI::PollClientFile: only on server");
   }
   else if(%player > 2048 && !isObject(2048))
   {
      RI::waitForPollResponse(%player);
      remoteEval(%player, RI::RequestFileInfo, %filename, %website, %filetype);
      
      schedule(
         "if(" @ %player @ ".pollResponse == false && " @ %player @ ".responseKey == " @ %player.responseKey @ ")" @
            "RI::sendInfoMessageBox(" @ %player @ ",\"" @ %filename @ "\",\"" @ %website @ "\",\"" @ %filetype @ "\");", 3);
   }
   else
   {
      echo('pollClient(<playerId>, <fileName>, <downloadWebsite>, [fileType])');
   }
}

// requestFileInfo to be called clientside
function remoteRI::RequestFileInfo(%player, %filename, %website, %filetype)
{  
   if(%player == 2048)
   {
      remoteEval(2048, RI::gotResponse);
      if(getPathOf(%filename) == "")
      {
         $RI::Message = "This map uses a custom " @ %filetype @ " and " @
                        "requires that you download " @ %filename @ " from " @
                        %website @ ". Would you like open this website in your" @
                        " browser now?";
         $RI::Website = %website;
         guiPushDialog(simCanvas,"RIWebsite.dlg");
      }
   }
}

function RI::waitForPollResponse(%player)
{
   if(!isObject(2048))
   {
      %player.pollResponse = false;
      %player.responseKey = "" @ getSimTime();
   }
}

// gotResponse to be called serverside
function remoteRI::gotResponse(%player)
{
   if(!isObject(2048))
   {
      %player.pollResponse = true;
      %player.responseKey = -1;
   }
}

function RI::sendInfoMessageBox(%player, %filename, %website, %filetype)
{
   messageBox(%player, "This map uses a custom " @ %filetype @ " and requires that you download " @ %filename @ " from " @ %website @ ". Please visit this website to download the file.");
}

function RI::WebsiteDialog(%result)
{
   guiPopDialog(simCanvas, 0);
   if(%result == "[yes]")
      HTMLopenAndGoWin(simCanvas, $RI::Website);
}

// Remote Dialog Stuff
//------------------------------------------------------------------------------

function RI::sendDialogInfo(%override)
{
   if(%override != "")
   {
      $RI::dlgVar1 = %override;
      $RI::dlgVar2 = "";
   }
      
   %dlgID = RI::PopDlgID();
   guiPopDialog(simCanvas, 0);
   remoteEval(2048, RI::ReceiveDialogInfo, %dlgID, $RI::dlgVar1, $RI::dlgVar2);
   $RI::dlgVar1 = "";
   $RI::dlgVar2 = "";
}

// ReceiveDialogInfo to be called serverside
function remoteRI::ReceiveDialogInfo(%player, %dlgID, %result1, %result2)
{
   if(!isObject(2048))
   {
      if(%player.dlgCommand[%dlgID] != "")
      {
         echo("Receiving dialog info from " @ %player @ ", dialog #" @ %dlgID @ ": " @ %result1 @ ", " @ %result2);
         %dlgCommand = %player.dlgCommand[%dlgID];
         %player.dlgCommand[%dlgID] = "";
         %player.dlgExpireTime[%dlgID] = "";
      
         eval(%dlgCommand @ "(" @ %player @ "," @ %dlgID @ ",\"" @ %result1 @ "\",\"" @ %result2 @"\");");
      }
   }
}

function RI::sendConfirmDialog(%player, %command, %title, %question, %expireTime)
{
   if(%expireTime <= 0)
   {
      %expireTime = 60;
   }

   if(isObject(2048))
   {
      echo("RI::sendConfirmDialog: only on server");
   }
   else if(%player > 2048)
   {
      $RI::dlgCount++;
      %player.dlgCommand[$RI::dlgCount] = %command;
      %player.dlgExpireTime[$RI::dlgCount] = getCurrentTime() + %expireTime;
      remoteEval(%player, RI::ConfirmBox, $RI::dlgCount, %title, %question);
      
      // The dialog is received as '[cancel]' if the player does not answer the
      // dialog within the expiration time.
      schedule(
         "if(" @ %player @ ".dlgExpireTime[" @ $RI::dlgCount @ "] == getCurrentTime())" @
            "remoteRI::ReceiveDialogInfo(" @ %player @ "," @ $RI::dlgCount @ ",\"[cancel]\");",%expireTime);
   }
   else
   {
      echo('RI::sendConfirmDialog(<playerId>, <cmd>, <title>, <question>, <expire time>');
   }
}

function RI::sendInputDialog(%player, %command, %title, %question, %expireTime)
{
   if(%expireTime <= 0)
   {
      %expireTime = 60;
   }

   if(isObject(2048))
   {
      echo("RI::sendInputDialog: only on server");
   }
   else if(%player > 2048)
   {
      $RI::dlgCount++;
      %player.dlgCommand[$RI::dlgCount] = %command;
      %player.dlgExpireTime[$RI::dlgCount] = getCurrentTime() + %expireTime;
      remoteEval(%player, RI::EditBox, $RI::dlgCount, %title, %question);

      // The dialog is received as '[cancel]' if the player does not answer the
      // dialog within the expiration time.
      schedule(
         "if(" @ %player @ ".dlgExpireTime[" @ $RI::dlgCount @ "] == getCurrentTime())" @
            "remoteRI::ReceiveDialogInfo(" @ %player @ "," @ $RI::dlgCount @ ",\"[cancel]\");",%expireTime);
   }
   else
   {
      echo('RI::sendInputDialog(<playerId>, <cmd>, <title>, <question>, <expire time>');
   }
}

function RI::sendInput2Dialog(%player, %command, %title, %question, %label1, %label2, %expireTime)
{
   if(%expireTime <= 0)
   {
      %expireTime = 60;
   }

   if(isObject(2048))
   {
      echo("RI::sendInput2Dialog: only on server");
   }
   else if(%player > 2048)
   {
      $RI::dlgCount++;
      %player.dlgCommand[$RI::dlgCount] = %command;
      %player.dlgExpireTime[$RI::dlgCount] = getCurrentTime() + %expireTime;
      remoteEval(%player, RI::Edit2Box, $RI::dlgCount, %title, %question, %label1, %label2);

      // The dialog is received as '[cancel]' if the player does not answer the
      // dialog within the expiration time.
      schedule(
         "if(" @ %player @ ".dlgExpireTime[" @ $RI::dlgCount @ "] == getCurrentTime())" @
            "remoteRI::ReceiveDialogInfo(" @ %player @ "," @ $RI::dlgCount @ ",\"[cancel]\");",%expireTime);
   }
   else
   {
      echo('RI::sendInput2Dialog(<playerId>, <cmd>, <title>, <question>, <label1>, <label2>, <expire time>');
   }
}

function RI::sendOptionDialog(%player, %command, %title, %question, %options, %expireTime)
{
   if(%expireTime <= 0)
   {
      %expireTime = 60;
   }

   if(isObject(2048))
   {
      echo("RI::sendOptionDialog: only on server");
   }
   else if(%player > 2048)
   {
      $RI::dlgCount++;
      %player.dlgCommand[$RI::dlgCount] = %command;
      %player.dlgExpireTime[$RI::dlgCount] = getCurrentTime() + %expireTime;
      remoteEval(%player, RI::OptionBox, $RI::dlgCount, %title, %question, %options);

      // The dialog is received as '[cancel]' if the player does not answer the
      // dialog within the expiration time.
      schedule(
         "if(" @ %player @ ".dlgExpireTime[" @ $RI::dlgCount @ "] == getCurrentTime())" @
            "remoteRI::ReceiveDialogInfo(" @ %player @ "," @ $RI::dlgCount @ ",\"[cancel]\");",%expireTime);
   }
   else
   {
      echo('RI::sendOptionDialog(<playerId>, <cmd>, <title>, <question>, <options (String w/\',\' delimiter)>, <expire time>');
   }
}

function RI::sendOption2Dialog(%player, %command, %title, %question, %label1, %label2, %options1, %options2, %expireTime)
{
   if(%expireTime <= 0)
   {
      %expireTime = 60;
   }

   if(isObject(2048))
   {
      echo("RI::sendOption2Dialog: only on server");
   }
   else if(%player > 2048)
   {
      $RI::dlgCount++;
      %player.dlgCommand[$RI::dlgCount] = %command;
      %player.dlgExpireTime[$RI::dlgCount] = getCurrentTime() + %expireTime;
      remoteEval(%player, RI::Option2Box, $RI::dlgCount, %title, %question, %label1, %label2, %options1, %options2);

      // The dialog is received as '[cancel]' if the player does not answer the
      // dialog within the expiration time.
      schedule(
         "if(" @ %player @ ".dlgExpireTime[" @ $RI::dlgCount @ "] == getCurrentTime())" @
            "remoteRI::ReceiveDialogInfo(" @ %player @ "," @ $RI::dlgCount @ ",\"[cancel]\");",%expireTime);
   }
   else
   {
      echo('RI::sendOption2Dialog(<playerId>, <cmd>, <title>, <question>, <label1>, <label2>, <options1 (String w/\',\' delimiter)>, <options2>, <expire time>');
   }
}

function RI::sendOptionInputDialog(%player, %command, %title, %question, %label1, %label2, %options, %expireTime)
{
   if(%expireTime <= 0)
   {
      %expireTime = 60;
   }

   if(isObject(2048))
   {
      echo("RI::sendOptionInputDialog: only on server");
   }
   else if(%player > 2048)
   {
      $RI::dlgCount++;
      %player.dlgCommand[$RI::dlgCount] = %command;
      %player.dlgExpireTime[$RI::dlgCount] = getCurrentTime() + %expireTime;
      remoteEval(%player, RI::OptionInputBox, $RI::dlgCount, %title, %question, %label1, %label2, %options);

      // The dialog is received as '[cancel]' if the player does not answer the
      // dialog within the expiration time.
      schedule(
         "if(" @ %player @ ".dlgExpireTime[" @ $RI::dlgCount @ "] == getCurrentTime())" @
            "remoteRI::ReceiveDialogInfo(" @ %player @ "," @ $RI::dlgCount @ ",\"[cancel]\");",%expireTime);
   }
   else
   {
      echo('RI::sendOptionInputDialog(<playerId>, <cmd>, <title>, <question>, <label1>, <label2>, <options (String w/\',\' delimiter)>, <expire time>');
   }
}

// ConfirmBox to be called clientside
function remoteRI::ConfirmBox(%player, %dlgID, %title, %question)
{
   if(%player == 2048)
   {
      RI::PushDlgID(%dlgID);
      $RI::DlgTitle = %title;
      $RI::DlgQuestion = %question;
      guiPushDialog(simCanvas, "RIConfirmBox.dlg");
   }
}

// EditBox to be called clientside
function remoteRI::EditBox(%player, %dlgID, %title, %question)
{
   if(%player == 2048)
   {
      RI::PushDlgID(%dlgID);
      $RI::DlgTitle = %title;
      $RI::DlgQuestion = %question;
      guiPushDialog(simCanvas, "RIEditBox.dlg");
   }
}

// Edit2Box to be called clientside
function remoteRI::Edit2Box(%player, %dlgID, %title, %question, %label1, %label2)
{
   if(%player == 2048)
   {
      RI::PushDlgID(%dlgID);
      $RI::DlgTitle = %title;
      $RI::DlgQuestion = %question;
      $RI::Dlglabel1 = %label1;
      $RI::Dlglabel2 = %label2;
      guiPushDialog(simCanvas, "RIEdit2Box.dlg");
   }
}

// OptionBox to be called clientside
function remoteRI::OptionBox(%player, %dlgID, %title, %question, %options)
{
   if(%player == 2048)
   {
      RI::PushDlgID(%dlgID);
      $RI::DlgTitle = %title;
      $RI::DlgQuestion = %question;
      guiPushDialog(simCanvas, "RIOptionBox.dlg");
      RI::InitOptionBox("OptionBox", %options);
   }
}

// Option2Box to be called clientside
function remoteRI::Option2Box(%player, %dlgID, %title, %question, %label1, %label2, %options1, %options2)
{
   if(%player == 2048)
   {
      RI::PushDlgID(%dlgID);
      $RI::DlgTitle = %title;
      $RI::DlgQuestion = %question;
      $RI::Dlglabel1 = %label1;
      $RI::Dlglabel2 = %label2;
      guiPushDialog(simCanvas, "RIOption2Box.dlg");
      RI::InitOptionBox("OptionBox", %options1);
      RI::InitOptionBox("OptionBox2", %options2);
   }
}

// OptionInputBox to be called clientside
function remoteRI::OptionInputBox(%player, %dlgID, %title, %question, %label1, %label2, %options)
{
   if(%player == 2048)
   {
      RI::PushDlgID(%dlgID);
      $RI::DlgTitle = %title;
      $RI::DlgQuestion = %question;
      $RI::Dlglabel1 = %label1;
      $RI::Dlglabel2 = %label2;
      guiPushDialog(simCanvas, "RIOptionEditBox.dlg");
      RI::InitOptionBox("OptionBox", %options);
   }
}

// Stuff for making the Option/Pulldown Boxes work
//------------------------------------------------------------------------------

function RI::InitOptionBox(%control, %options)
{
   Popup::Clear(%control);
   Control::SetText(%control, "Select Option...");
   //Popup::AddLine(OptionBox, "Select Option...", -1);
   
   %length = strtok("" @ %options, ",", "RI::Options");
   for(%i = 0; %i < %length; %i++)
      Popup::AddLine(%control, $RI::Options[%i], %i);
}

function OptionBox::onSelect(%string, %level)
{
   $RI::dlgVar1 = %string;
}

function OptionBox2::onSelect(%string, %level)
{
   $RI::dlgVar2 = %string;
}

// Client Dialog Stack Stuff
//------------------------------------------------------------------------------

$RI::DlgStackSize = 0;

function RI::PushDlgID(%dlgID)
{
   $RI::DlgID[$RI::DlgStackSize] = %dlgID;
   $RI::DlgStackSize++;
}

function RI::PopDlgID()
{
   %dlgID = $RI::DlgID[$RI::DlgStackSize - 1];
   $RI::DlgID[$RI::DlgStackSize - 1] = "";
   $RI::DlgStackSize--;
   return %dlgID;
}

// Miscellaneous
//------------------------------------------------------------------------------

function RI::TestCommand(%player, %dlgID, %result1, %result2)
{
   say(0,0,getName(%player) @ " returned the results for dialog #" @ %dlgID @
      ": (" @ %result1 @ ") (" @ %result2 @ ")");
}

// Some other required things (taken from GLUtil.cs)
//------------------------------------------------------------------------------

//-------------------------------------------------------
// strtok
//	- Grabs tokens from a string.
//	- Tokens are placed into global array.
//	- Optional starting position.
//	- Requires FindString(), GrabChars(), FastGrabChars()
//
//	RETURNS:
//	- Number of tokens collected.
//-------------------------------------------------------
function strtok(%str,%tok,%array_name,%start)
{
//echo("strtok( <string>, <token>, <array name>, <start position> );");
if(%start=="")%start=0;
%t=-1;

while( ((%i=FindString(%str,%tok,%start)) != -1) )
{
%t++;
eval("$"@%array_name@%t@"=FastGrabChars(%str,c,abs(%i-%start),%start);");
%start=%i+1;
}

%t++;
eval("$"@%array_name@%t@"=FastGrabChars(%str,c,abs((%start)-strlen(%str)),%start);");

return %t+1;
}

//-------------------------------------------------------
// FindString 1.5
//	- Finds position of substring starting at a given point.
//	- Starting point is optional.
//
//	RETURNS:
//	- Negative One if substring can't be found.
//	- Position of substring if it is found.
//-------------------------------------------------------

function FindString(%str,%c,%start)
{
//echo("FindString( <string>, <sub string>, <start position> );");
if(%start=="")%start=0;
%str=convertspaces(%str);
%c=convertspaces(%c);
for(%x=%start;%x<strlen(%str);%x++)
{
if(strcat(strAlign(%x,left,%str),%c)==strAlign(%x+strlen(%c),left,%str))
{
return %x;
}
}
return -1;
}

//-------------------------------------------------------
// GrabChars 3.0
//	- Grabs characters from the left, center, or right of a string.
//	- Supports character case conversion.
//	- Requires letterCheck()
//
//	FAST PROCESSING:
//	- Processes a space (' ') to a '~', which includes every keyboard key.
//	- Skips 128 uncommon characters.
//
//	NON-FAST PROCESSING:
//	- Processes a space to a 'y' with two dots over it.
//	- Processes all 223 valid characters.
//
//	INVALID CHARACTERS:
//	- Anything below the ANSI space (' ') will screw up GrabChars.
//	- This is anything 0 to 31, hex range 0x00 to 0x1F.
//	- These are often used to "cheat" in SS, so they are skipped.
//
//	USAGE:
//	- GrabChars( <str>, <dir: l/c/r>, <num>, <start>, <fast: 1 or 0>, <case: lower/upper> );
//
//	RETURNS:
//	- Resulting string.
//-------------------------------------------------------

function GrabChars(%str,%dir,%num,%start,%fast,%case)
{
//echo("GrabChars( <string>, <direction: l/c/r>, <number to grab>, <start position>, <fast: 1 or 0>, <case: upper/lower> );");
if(%start=="") %start=0;
if(%fast==""||%fast==0) %fast=2;
%str=ConvertSpaces(%str);

if(%dir == c || %dir == "c")
%len=%start+%num;
else if(%dir == l || %dir == "l")
%len=%num;
else if(%dir == r || %dir == "r")
{
%len = strlen(%str);
%start=%len-%num;
}

for(%x=%start+1;%x<=%len;%x++)
{
%letter[%x] = letterCheck(strAlign(%x, l, %str),%fast,%case);
if(%letter[%x] == "_") %letter[%x]=" ";
}

if(%dir == l || %dir == "l")
{
for(%x=%start;%x<=%len;%x++)
{
%end=strcat(%end,%letter[%x]);
}
}
else if(%dir == r || %dir == "r")
{
for(%x=%len;%x>=%start;%x--)
{
%end=strcat(%letter[%x], %end);
}
}
else if(%dir == c || %dir == "c")
{
for(%x=%start;%x<=%len;%x++)
{
%end=strcat(%end,%letter[%x]);
}
}
return(%end);
}

//-------------------------------------------------------
// FastGrabChars
//	- Always using fast option (Read GrabChars comment).
//
//	RETURNS:
//	- Resulting string.
//-------------------------------------------------------

function FastGrabChars(%str,%dir,%num,%start,%case)
{
//echo("FastGrabChars( <string>, <direction: l/c/r>, <number to grab>, <start position>, <case: upper/lower> );");
return GrabChars(%str,%dir,%num,%start,1,%case);
}

//-------------------------------------------------------
// letterCheck v2.0
//	- Thanks to Dull for his original function.
//	- Contains core processing of GrabChars.
//
//	RETURNS:
//	- Character matching end character of string passed.
//-------------------------------------------------------

function letterCheck(%str,%fast,%case)
{
%last = strAlign((strlen(%str) - 1), l, %str);

if(%fast==1)
%max_x=7;
else
%max_x=15;

for(%x=2;%x<=%max_x;%x++)
{
for(%y=0;%y<=15;%y++)
{
eval("%tmp3=\"\\x"@strcat($HEX[%x],$HEX[%y])@"\";");

if( ( %str == strcat(%last, "e") ) && (%tmp3 == "+") )
%tmp3="e";
else
if( ( %str == strcat(%last, "E") ) && (%tmp3 == "+") )
%tmp3="E";

if( %str == strcat(%last, %tmp3 ) )
{
if( ( %case=="lower" || %case==lower ) && (%tmp3>="A" && %tmp3<="Z") )
eval("%tmp3=\"\\x"@strcat(%x+2,%tmp2)@"\";");
else
if( ( %case=="upper" || %case==upper ) && (%tmp3>="a" && %tmp3<="z") )
eval("%tmp3=\"\\x"@strcat(%x-2,%tmp2)@"\";");
return %tmp3;
}
}
}
}

//-------------------------------------------------------
// Hex <-> Integer conversion arrays
//
//	- All GrabChars functions need this.
//	- All Hex, Char, and Int conversion functions need this.
//-------------------------------------------------------

$HEX0=0;
$HEX1=1;
$HEX2=2;
$HEX3=3;
$HEX4=4;
$HEX5=5;
$HEX6=6;
$HEX7=7;
$HEX8=8;
$HEX9=9;
$HEX10=A;
$HEX11=B;
$HEX12=C;
$HEX13=D;
$HEX14=E;
$HEX15=F;
$HEX[A]=10;
$HEX[B]=11;
$HEX[C]=12;
$HEX[D]=13;
$HEX[E]=14;
$HEX[F]=15;
